/* Brute force with analys at start */
#include <cstdio>
#include <algorithm>

using namespace std;

const char *infile="catacomb.dat";
const char *outfile="catacomb.sol";

const int maxLevels=10;
const int maxMoveCnt=maxLevels*(1<<maxLevels);

int a[1<<maxLevels];
int mcnt=0;
int moves[maxMoveCnt][2];
int fmcnt=0;
int fmoves[maxMoveCnt][2];
int icnt=0;
int intervals[1<<maxLevels][2];
int fault[1<<maxLevels];

int SwapCost(int x,int y) {
     int res=0;
     while((x&~((1<<res)-1))!=(y&~((1<<res)-1)))res++;
     return res;
}

void check(int beg,int n,int &icnt,int intervals[][2],int fault[]){
	int mid,end,i;
	end=beg+(1<<n);
	mid=beg+(1<<n-1);
	int fcount=0;
	for(i=beg;i<end;i++)
		fcount+=(a[i]<beg||a[i]>=end);
	if (fcount>1||n>4)
	{
		check(beg,n-1,icnt,intervals,fault);
		check(mid,n-1,icnt,intervals,fault);
	}else
	{	
		intervals[icnt][0]=beg;
		intervals[icnt][1]=end;
		for(i=beg;!(a[i]<beg||a[i]>=end);i++);
		fault[icnt]=i;
		icnt++;
	}
	return;
}

int solve(int beg,int n,int &mcnt,int moves[][2],int ans) {
     int cur;
     int i;
     int left[1<<maxLevels],right[1<<maxLevels];
     int lCnt,rCnt,mid,end;
     int mleft,mright;
     int cm[maxMoveCnt][2];
     if(n==0) {
          mcnt=0;
          return 0;
     }
     mid=beg+(1<<n-1);
     end=beg+(1<<n);
     for(i=beg,lCnt=0;i<mid;i++)
          if(a[i]>=mid)left[lCnt++]=i;
     for(i=mid,rCnt=0;i<end;i++)
          if(a[i]<mid)right[rCnt++]=i;
     do {
          for(i=0;i<lCnt;i++)swap(a[left[i]],a[right[i]]),cm[i][0]=left[i],cm[i][1]=right[i];
          cur=rCnt*n;
          if(cur<ans)cur+=solve(beg,n-1,mleft,cm+lCnt,ans-cur);
          if(cur<ans)cur+=solve(mid,n-1,mright,cm+lCnt+mleft,ans-cur);
          if(cur<ans) {
               ans=cur;
               mcnt=lCnt+mleft+mright;
               for(i=0;i<mcnt;i++)moves[i][0]=cm[i][0],moves[i][1]=cm[i][1];
          }
//          ans=min(ans,rCnt*n+solve(beg,n-1)+solve(beg+ (1<<n-1),n-1));
          for(i=0;i<lCnt;i++)swap(a[left[i]],a[right[i]]);
     }while(next_permutation(right,right+rCnt));
     return ans;
}

int main() {
     int i,j,x,ans,n,levels;
     FILE *ifs=fopen(infile,"r");
     FILE *ofs=fopen(outfile,"w");
     
     fscanf(ifs,"%d",&levels);
     n=(1<<levels);
     for(i=0;i<n;i++)fscanf(ifs,"%d",&a[i]),a[i]--;
     ans=0;
     check(0,levels,icnt,intervals,fault);
     for(i=0;i<icnt;i++)
     	for(j=i+1;j<icnt;j++)
		 	if((a[fault[i]]>=intervals[j][0]&&a[fault[i]]<intervals[j][1])&&(a[fault[j]]>=intervals[i][0]&&a[fault[j]]<intervals[i][1])){
				x=a[fault[i]];
				a[fault[i]]=a[fault[j]];
				a[fault[j]]=x;
				ans+=SwapCost(fault[i],fault[j]);
				fmoves[fmcnt][0]=fault[i];
				fmoves[fmcnt][1]=fault[j];
				fmcnt++;
			}
     ans+=solve(0,levels,mcnt,moves,1000000000);
     fprintf(ofs,"%d\n",4*ans);
     fprintf(ofs,"%d\n",mcnt+fmcnt);
     for(i=0;i<fmcnt;i++)fprintf(ofs,"%d %d\n",fmoves[i][0]+1,fmoves[i][1]+1);
     for(i=0;i<mcnt;i++)fprintf(ofs,"%d %d\n",moves[i][0]+1,moves[i][1]+1);
     fclose(ifs);
     fclose(ofs);
     return 0;
}

