/* Brute force */
#include <cstdio>
#include <algorithm>

using namespace std;

const char *infile="catacomb.dat";
const char *outfile="catacomb.sol";

const int maxLevels=10;
const int maxMoveCnt=maxLevels*(1<<maxLevels);

int a[1<<maxLevels];

int solve(int beg,int n,int &mcnt,int moves[][2],int ans) {
     int cur;
     int i;
     int left[1<<maxLevels],right[1<<maxLevels];
     int lCnt,rCnt,mid,end;
     int mleft,mright;
     int cm[maxMoveCnt][2];
     if(n==0) {
          mcnt=0;
          return 0;
     }
     mid=beg+(1<<n-1);
     end=beg+(1<<n);
     for(i=beg,lCnt=0;i<mid;i++)
          if(a[i]>=mid)left[lCnt++]=i;
     for(i=mid,rCnt=0;i<end;i++)
          if(a[i]<mid)right[rCnt++]=i;
     do {
          for(i=0;i<lCnt;i++)swap(a[left[i]],a[right[i]]),cm[i][0]=left[i],cm[i][1]=right[i];
          cur=rCnt*n;
          if(cur<ans)cur+=solve(beg,n-1,mleft,cm+lCnt,ans-cur);
          if(cur<ans)cur+=solve(mid,n-1,mright,cm+lCnt+mleft,ans-cur);
          if(cur<ans) {
               ans=cur;
               mcnt=lCnt+mleft+mright;
               for(i=0;i<mcnt;i++)moves[i][0]=cm[i][0],moves[i][1]=cm[i][1];
          }
//          ans=min(ans,rCnt*n+solve(beg,n-1)+solve(beg+ (1<<n-1),n-1));
          for(i=0;i<lCnt;i++)swap(a[left[i]],a[right[i]]);
     }while(next_permutation(right,right+rCnt));
     return ans;
}

int main() {
     int i,ans,n,levels;
     int mcnt;
     int moves[maxMoveCnt][2];
     FILE *ifs=fopen(infile,"r");
     FILE *ofs=fopen(outfile,"w");
     
     fscanf(ifs,"%d",&levels);
     n=(1<<levels);
     for(i=0;i<n;i++)fscanf(ifs,"%d",&a[i]),a[i]--;
     
     ans=solve(0,levels,mcnt,moves,1000000000);
     fprintf(ofs,"%d\n",4*ans);
     fprintf(ofs,"%d\n",mcnt);
     for(i=0;i<mcnt;i++)fprintf(ofs,"%d %d\n",moves[i][0]+1,moves[i][1]+1);
     fclose(ifs);
     fclose(ofs);
     return 0;
}
