/* Brute force with euristic of swap in pairs */
#include <cstdio>
#include <algorithm>

using namespace std;

const char *infile="catacomb.dat";
const char *outfile="catacomb.sol";

const int maxD=10;
const int maxMoveCnt=maxD*(1<<maxD);

int a[1<<maxD];

int solve(int beg,int d,int &mcnt,int moves[][2],int ans) {
     int cur;
     int i;
     int left[1<<maxD],right[1<<maxD];
     int lCnt,rCnt,mid,end,pCnt;
     int mleft,mright;
     int cm[maxMoveCnt][2];
     if(d==0) {
          mcnt=0;
          return 0;
     }
     mid=beg+(1<<d-1);
     end=beg+(1<<d);
     pCnt=0;
     for(i=beg,lCnt=0;i<mid;i++)
          if(a[i]>=mid) 
                if(a[a[i]]==i) {
                    cm[pCnt][0]=i;cm[pCnt++][1]=a[i];
                    swap(a[i],a[a[i]]);
                }
                else left[lCnt++]=i;
     for(i=mid,rCnt=0;i<end;i++)
          if(a[i]<mid)right[rCnt++]=i;
     do {
          for(i=0;i<lCnt;i++)swap(a[left[i]],a[right[i]]),cm[pCnt+i][0]=left[i],cm[pCnt+i][1]=right[i];
          cur=(pCnt+rCnt)*d;
          if(cur<ans)cur+=solve(beg,d-1,mleft,cm+pCnt+lCnt,ans-cur);
          if(cur<ans)cur+=solve(mid,d-1,mright,cm+pCnt+lCnt+mleft,ans-cur);
          if(cur<ans) {
               ans=cur;
               mcnt=pCnt+lCnt+mleft+mright;
               for(i=0;i<mcnt;i++)moves[i][0]=cm[i][0],moves[i][1]=cm[i][1];
          }
//          ans=min(ans,rCnt*n+solve(beg,n-1)+solve(beg+ (1<<n-1),n-1));
          for(i=0;i<lCnt;i++)swap(a[left[i]],a[right[i]]);
     }while(next_permutation(right,right+rCnt));
     for(i=0;i<pCnt;i++)swap(a[cm[i][0]],a[cm[i][1]]);
     return ans;
}

int main() {
     int i,ans,d;
     int mcnt;
     int moves[maxMoveCnt][2];
     FILE *ifs=fopen(infile,"r");
     FILE *ofs=fopen(outfile,"w");
     
     fscanf(ifs,"%d",&d);
     for(i=0;i<1<<d;i++)fscanf(ifs,"%d",&a[i]),a[i]--;
     
     ans=solve(0,d,mcnt,moves,1000000000);
     fprintf(ofs,"%d\n",4*ans);
     fprintf(ofs,"%d\n",mcnt);
     for(i=0;i<mcnt;i++)fprintf(ofs,"%d %d\n",moves[i][0]+1,moves[i][1]+1);
     fclose(ifs);
     fclose(ofs);
     return 0;
}
