#include <algorithm>

using namespace std;

const int maxL=10;

int SwapCost(int x,int y) {
     int res=0;
     while((x&~((1<<res)-1))!=(y&~((1<<res)-1)))res++;
     return 4*res;
}

bool Check(int n,int a[],FILE *ofs) {
     int cost,k,i,x,y;
     fscanf(ofs,"%d%d",&cost,&k);
     while(k--) {
          fscanf(ofs,"%d%d",&x,&y);
          x--;y--;
          cost-=SwapCost(x,y);
//          printf("swap a[%d]=%d and a[%d]=%d cost=%d\n",x,a[x],y,a[y],SwapCost(x,y));
          if(x==y)return false;
          a[x]=a[x]^a[y];
          a[y]=a[x]^a[y];
          a[x]=a[x]^a[y];
//          printf("got: ");
//          for(i=0;i<n;i++)printf("%d ",a[i]);
//          printf("\n");
     }
     if(cost)return false;
     for(i=0;i<n;i++)
          if(a[i]!=i+1)return false;              
     return true;
}

int main(int argc,char *argv[]) {
     int a[1<<maxL];
     int n,i;
     if(argc!=3) {
            fprintf(stderr,"usage: %s <in_file> <out_file>\n");
            return 1;
     }     
     FILE *ifs=fopen(argv[1],"r");
     FILE *ofs=fopen(argv[2],"r");
     fscanf(ifs,"%d",&n);
     for(i=0;i<1<<n;i++)fscanf(ifs,"%d",&a[i]);
     if(Check(1<<n,a,ofs))printf("OK!\n");
     else printf("WA!\n");
     return 0;
}
