{ fp }

(*
 * Problem  :   DISCOUNT
 * Contest  :   UOI-2008 (LVIV)
 * Type     :   Solution
 * Date     :   March 18, 2008
 * Version  :   1.0
 * Author   :   Shamil Yagiyayev
 * Language :   Pascal
 * Compiler :   FPC 2.0.4
 * Link     :   http://www.freepascal.org/
 * Algorithm:   N^2 solution
 *)

const
  MAX_N = 10000;
var
  n, i, sum : Longint;
  A : array[1..MAX_N] of integer;

procedure swap(var a : integer; var b : integer);
var c : integer;
begin
  c:=a;
  a:=b;
  b:=c;
end;

procedure bubbleSort;
var 
  i, j : integer;
begin
  for i := 1 to n-1 do
    for j := 1 to n-1 do
      if (a[j] < a[j+1]) then swap(a[j], a[j+1]);
end;

begin
  Assign(input, 'discount.dat');
  Reset(input);
  ReadLn(n);
  for i:=1 to n do
    Read(A[i]);
  Close(input);

  bubbleSort;

  sum := 0;
  for i := 1 to n do
    if i mod 3 <> 0 then sum := sum + a[i];

  Assign(output, 'discount.sol');
  Rewrite(output);
  Writeln(sum);
  Close(output);
end.

